Unit TestAD;
{ ========================================================================== }
{ =   Lynx Tecnologia Eletrnica Ltda.                                     = }
{ =   Projeto:   Windows NT4.0 Drivers - CAD12/56       Data: 29/mai/2000  = }
{ =   Programa:  Teste do driver da CAD12/56 para Windows NT4.0            = }
{ =   Mdulo:    TestAD                                                    = }
{ =   Autor:     Lauro                                                     = }
{ =   Descrio: Teste da entradas analgicas por WFF.                     = }
{ =   Verso:    1.0                                                       = }
{ ========================================================================== }

{-------------------------  Descrio da Interface  -------------------------}
Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     ExtCtrls, StdCtrls, Buttons, Spin, ComCtrls;


{ ===================================================== }
{ =               Declarao de tipos                 = }
{ ===================================================== }

Type
  TdlgTestAD = class (TForm)
    btClose    : TBitBtn;
    gbTableAD  : TGroupBox;
    cbFaixa_0  : TComboBox;
    cbFaixa_1  : TComboBox;
    cbFaixa_2  : TComboBox;
    cbFaixa_3  : TComboBox;
    seCanal_0  : TSpinEdit;
    seCanal_1  : TSpinEdit;
    seCanal_2  : TSpinEdit;
    seCanal_3  : TSpinEdit;
    panValBin_0: TPanel;
    panValBin_1: TPanel;
    panValBin_2: TPanel;
    panValBin_3: TPanel;
    panValTen_0: TPanel;
    panValTen_1: TPanel;
    panValTen_2: TPanel;
    panValTen_3: TPanel;
    panStatus  : TPanel;
    panTiBin   : TPanel;
    panTiCanal : TPanel;
    panTiFaixa : TPanel;
    panTiTensao: TPanel;
    tmrUpdate  : TTimer;
    seCnDA     : TSpinEdit;
    lblCnDA    : TLabel;
    tbValDA    : TTrackBar;
    Procedure FormCreate (Sender: TObject);
    Procedure FormClose (Sender: TObject; var Action: TCloseAction);
    Procedure seCnDAChange(Sender: TObject);
    Procedure tbValDAChange(Sender: TObject);
    Procedure tmrUpdateTimer (Sender: TObject);
  private
    { Private declarations }
    SelCnDA: smallint;       { Canal D/A selecionado }
    ValDA  : array [0..3] of smallint;
    Procedure Leitura (Canal, iFaixa: smallint; panBinario, panTensao: TPanel);
  public
    { Public declarations }
  end;


{ ===================================================== }
{ =                Variveis globais                  = }
{ ===================================================== }

  Var dlgTestAD: TdlgTestAD;


{-------------------------  Descrio da Implementao ----------------------}
Implementation
  Uses NT4api;

{$R *.DFM}


{ ========================================================================== }
{ =                  Implementao do objeto TdlgTestAD                    = }
{ ========================================================================== }

{------------------------------------------- TdlgTestAD: Cria o dialog box --}
Procedure TdlgTestAD.FormCreate (Sender: TObject);
  Var i   : smallint;
      sAux: string;
begin
  cbFaixa_0.Clear;
  cbFaixa_1.Clear;
  cbFaixa_2.Clear;
  cbFaixa_3.Clear;
  for  i := 0 to Pred (DriverInfo.nAiRange)  do
  begin
    if  DriverInfo.AiRange [i] < 0  then
      sAux := Format ('%.5g a %.5g V', [DriverInfo.AiRange [i], -DriverInfo.AiRange [i]])
    else
      sAux := Format ('0 a %.5g V', [DriverInfo.AiRange [i]]);
    cbFaixa_0.Items.Add (sAux);
    cbFaixa_1.Items.Add (sAux);
    cbFaixa_2.Items.Add (sAux);
    cbFaixa_3.Items.Add (sAux);
  end;

  cbFaixa_0.ItemIndex := 0;
  cbFaixa_1.ItemIndex := 1;
  cbFaixa_2.ItemIndex := 2;
  cbFaixa_3.ItemIndex := 3;
  seCanal_0.Value     := 0;
  seCanal_1.Value     := 1;
  seCanal_2.Value     := 2;
  seCanal_3.Value     := 3;
  tmrUpdate.Enabled   := false;
  SelCnDA := 0;
  for  i := 0 to 3  do ValDA [0] := 0;
  seCnDA.Value := 0;
end;

{------------------ TdlgTestAD: Inibe o timer antes de fechar o dialog box --}
Procedure TdlgTestAD.FormClose (Sender: TObject; var Action: TCloseAction);
begin
  tmrUpdate.Enabled := false;
end;

{---------- TdlgTestAD: Realiza leitura de um canal A/D e atualiza display --}
Procedure TdlgTestAD.Leitura (Canal, iFaixa: smallint; panBinario, panTensao:TPanel);
  Var vBin   : smallint;
      vVolt  : single;
      m      : single;
      AiRange: single;
begin
  NT4_SetAiRange (iFaixa);
  if  NT4_ReadAI (Canal, vBin) = 0
  then begin
    panStatus.Caption  := '';
    panBinario.Caption := IntToStr (vBin);
    AiRange := DriverInfo.AiRange [iFaixa];
    if  AiRange  < 0  then {  bipolar ? }
      vVolt := -AiRange / 32768.0 * vBin
    else begin
      m     := (AiRange - 0) / 65536.0;
      vVolt := m * (vBin + 32768.0);
    end;
    panTensao.Caption := Format ('%8.4f', [vVolt]);
  end
  else begin
    panStatus.Caption  := 'Erro no conversor A/D!';
    panBinario.Caption := '';
    panTensao.Caption  := '';
  end;
end;

{----------------------- TdlgTestAD: Trata mudana na seleo do canal D/A --}
Procedure TdlgTestAD.seCnDAChange (Sender: TObject);
begin
  SelCnDA := seCnDA.Value;
  tbValDA.Position := ValDA [SelCnDA];
end;

{------------------------------------ TdlgTestAD: Atualiza sada analgica --}
Procedure TdlgTestAD.tbValDAChange (Sender: TObject);
begin
  ValDA [SelCnDA] := tbValDA.Position;
  NT4_WriteAo (SelCnDA, ValDA [SelCnDA]);
end;

{----------------- TdlgTestAD: Realiza leitura dos canais A/D selecionados --}
Procedure TdlgTestAD.tmrUpdateTimer (Sender: TObject);
begin
  Leitura (seCanal_0.Value, cbFaixa_0.ItemIndex, panValBin_0, panValTen_0);
  Leitura (seCanal_1.Value, cbFaixa_1.ItemIndex, panValBin_1, panValTen_1);
  Leitura (seCanal_2.Value, cbFaixa_2.ItemIndex, panValBin_2, panValTen_2);
  Leitura (seCanal_3.Value, cbFaixa_3.ItemIndex, panValBin_3, panValTen_3);
end;

end.
